var admin_centroid = require('../request/admin_centroid');

let _apikey = ''
let _url = ''

module.exports = {
  async init(input) {
    _apikey = input.apikey
    _url = input.url
  }

  ,async detect(input) {
    const { address, lat, lng } = input
    let params = {
      address: address,
      latitude: lat,
      longitude: lng,
      'Api-Key': _apikey
    }

    let return_output = {
      type: 'admin_centroid',
      status: false,
      is_wrong: false,
      confidence: 0,
      case: 0,
      details: ''
    }

    if (address) {
      if (!_url) {return { error: 'You need init Admin Centroid URL' }}

      let check = await admin_centroid.check(`${_url}`, params)

      if (check) {
        if (check.results) {
          if (check.results.wrong_confidence && check.results.wrong_confidence > 0) {
            return_output.is_wrong = true
            return_output.confidence = check.results.wrong_confidence
          }
        } else if (check.error) {
          return_output.is_wrong = true
          return_output.confidence = 100
          return_output.details = check.error.message
        }
      }
    }

    return return_output
  }
}