var slug = require('./slug');
var enum_match = require('../../const/matching_case');

module.exports = {
  split_num_str (order) {
    let num = ''
    let str = ''
    let indexStart = 0
    let is_hem = false

    if (order) {
      if (order.toLowerCase().indexOf('/') > -1) { is_hem = true; }
      if (order.toLowerCase().indexOf('ngo') > -1) { is_hem = true; indexStart = order.toLowerCase().indexOf('ngo') + 3; str = order.substr(indexStart + 1, order.length - indexStart)}
      if (order.toLowerCase().indexOf('ngõ') > -1) { is_hem = true; indexStart = order.toLowerCase().indexOf('ngõ') + 3; str = order.substr(indexStart + 1, order.length - indexStart)}
      if (order.toLowerCase().indexOf('hem') > -1) { is_hem = true; indexStart = order.toLowerCase().indexOf('hem') + 3; str = order.substr(indexStart + 1, order.length - indexStart)}
      if (order.toLowerCase().indexOf('hẻm') > -1) { is_hem = true; indexStart = order.toLowerCase().indexOf('hẻm') + 3; str = order.substr(indexStart + 1, order.length - indexStart)}
    
      if (num == '' && str) {
        indexEnd = str.indexOf(' ')
        num = str.substr(0, indexEnd)
        str = str.replace(num, '')
      } else {
        if (Number.isInteger(parseInt(order)))
        {
          indexEnd = order.indexOf(' ')
          num = order.substr(0, indexEnd)
          str = order.replace(num, '')
        } else {
          num = ''
          str = order
        }
      }

      num = slug.stringToSlugToConnect(num)
      str = slug.stringToSlugToConnect(str)
    } else {
      num = ''
      str = ''
    }

    return {
      is_hem: is_hem,
      num: num,
      str: str,
      pure_str: order.toLowerCase()
    }
  }

  // a: object address
  // n: object nearest
  ,filter_osrm (a, n) {
    let returnObject = {
      type: 'osrm',
      is_wrong: false,
      case: enum_match.default,
      details: ''
    }

    // Rule Wrong :
    // 1. Đường A khác Đường N
    // 2. Cùng đường => A là đường, N là hẻm
    // 3. Cùng đường => A và N đều có hẻm => Số hẻm A và N khác nhau

    // Check Null Address Input
    if (!a.num && !a.str) {
      returnObject.is_wrong = true
      returnObject.code = enum_match.wrong_2000
      returnObject.details = 'Địa chỉ nhập vào không hợp lệ'
      return returnObject
    }

    // Check NULL nearest
    if (!n.num && !n.str) {
      returnObject.is_wrong = false
      returnObject.confidence = 100
      returnObject.code = enum_match.true_1001
      returnObject.details = 'OSRM nearest không có dữ liệu'
      return returnObject
    }

    if (
      a.str.indexOf(n.str) > -1 ||
      n.str.indexOf(a.str) > -1
    ) {

      if (!a.is_hem && n.is_hem) {
        if (
          a.num.indexOf(n.num) > -1 &&
          n.num.indexOf(a.num) > -1 &&
          a.str.indexOf(n.str) > -1 &&
          n.str.indexOf(a.str) > -1
        ) {
          returnObject.is_wrong = false
          returnObject.confidence = 100
          returnObject.code = enum_match.true_1002,
          returnObject.details = 'Nearest trả về hẻm, Address không có hẻm. Nhưng số nhà Address trùng với số hẻm nearest'
        } else {
          returnObject.is_wrong = true
          returnObject.confidence = 100
          returnObject.code = enum_match.wrong_2001,
          returnObject.details = 'Nearest trả về hẻm, Address không có hẻm'
        }
      } else if (a.is_hem && n.is_hem) {
        if (a.num.indexOf(n.num) < 0 && n.num.indexOf(a.num) < 0) {
          returnObject.is_wrong = true
          returnObject.confidence = 100
          returnObject.code = enum_match.wrong_2002,
          returnObject.details = 'Cùng đường, khác hẻm'
        } else if (a.num.substr(0,2) == n.num.substr(0,2)) {
          returnObject.is_wrong = false
          returnObject.confidence = 100
          returnObject.code = enum_match.right,
          returnObject.details = 'Trường hợp cùng đường, cùng hẻm, khác xuyệt'
        }
      } else if (!a.is_hem && !n.is_hem) {
        if (a.num != n.num)
        {
          returnObject.is_wrong = false
          returnObject.confidence = 100
          returnObject.code = enum_match.right,
          returnObject.details = 'PASS'
        }
      } else if (a.is_hem && !n.is_hem) {
        if (a.num != n.num)
        {
          returnObject.is_wrong = false
          returnObject.confidence = 100
          returnObject.code = enum_match.true_1003,
          returnObject.details = 'Cùng đường, không giống số'
        }
      }
    } else {
      // Case Đặc Biệt, Hard code cho đúng
      returnObject.is_wrong = true
      returnObject.confidence = 100
      returnObject.code = enum_match.wrong_2003
      returnObject.details = 'Khác đường'
    }
    // console.log(a)
    // console.log(n)
    return returnObject
  }
}