var axios = require('axios')

module.exports = {
  async check(url, params) {
    let err, results
    try {  
      const optionsAxios = {
        url: url,
        method: 'GET',
        headers: {
          'Content-Type': 'application/json',
        },
        json: true,
        params: params
      }
  
      let response = await axios.get(optionsAxios.url, optionsAxios)
      
      if (response && response.status && response.status >= 400) {
        err = { title: 'Error call API' }
      }

      results = response.data
    } catch (error) {
      err = {
        'message' : 'Cannot check admin centroid',
        'details' : error.toString()
      }
    }

    return {
      error: err,
      results: results
    }
  }
}