jest.setTimeout(30000)
var detectLocation = require('../index')

// ,"wrong_2000": 2000  // Input invalid
// ,"wrong_2001": 2001  // Nearest trả về hẻm, Address không có hẻm
// ,"wrong_2002": 2002  // Cùng đường, khác hẻm
// ,"wrong_2003": 2003  // Khác đường
// ,"wrong_2004": 2004  // Cùng đường, không giống số
// ,"wrong_2005": 2005  // Bắt đầu bằng tên đường
// ,"wrong_2006": 2006  // Bắt đầu bằng Đường, Tổ, Phố, Ấp, Khu công nghiệp ....
// ,"wrong_2007": 2007  // Có chứa tổ|ấp|khu phố|khu đô thị|lô|kiot
// ,"wrong_2008": 2008  // 'Địa danh không bắt đầu bằng số nhà'
// ,"wrong_2009": 2009  // 'Chữ ngay sau số nhà'
// ,"wrong_2010": 2010  // 'Bắt đầu bằng 1_'

detectLocation.Init({
  osrm_url: 'https://route.ahamove.com/osrm'
})

// TEST WITH ADDRESS
test('223 Dai Mo, Đại Mỗ, Nam Từ Liêm',
async (done) => {
  let data = await detectLocation.check_address({
    address: '223 Dai Mo, Đại Mỗ, Nam Từ Liêm',
    osrm_address: 'Ngõ 223 Đường Đại Mỗ',
    profile: 'osrm'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2001)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('59/ 1D Phạm Văn Chiêu,  phường 14,  Gò Vấp',
async (done) => {
  let data = await detectLocation.check_address({
    address: '59/ 1D Phạm Văn Chiêu,  phường 14,  Gò Vấp',
    osrm_address: 'Hẻm 205/31 Phạm Văn Chiêu',
    profile: 'osrm'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2002)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('369 Hoàng Hoa Thám, Ba Đình, Ha Noi',
async (done) => {
  let data = await detectLocation.check_address({
    address: '369 Hoàng Hoa Thám, Ba Đình, Ha Noi',
    osrm_address: 'Phố Phan Đình Phùng',
    profile: 'osrm'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2003)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Hẻm 369 Hoàng Hoa Thám, Ba Đình, Ha Noi',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Hẻm 369 Hoàng Hoa Thám, Ba Đình, Ha Noi',
    osrm_address: 'Đề Thám, Ba Đình, Ha Noi',
    profile: 'osrm'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2003)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

// TEST WITH LAT LNG
test('299 Đường Đại Mỗ',
async (done) => {
  let data = await detectLocation.check_address({
    address: '299 Đường Đại Mỗ',
    lat: 20.995229,
    lng: 105.759090,
    profile: 'osrm'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2001)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Hẻm 198 Phan Đăng Lưu',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Hẻm 198 Phan Đăng Lưu',
    lat: 10.800757,
    lng: 106.681199,
    profile: 'osrm'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2002)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('200 Thích Quảng Đức',
async (done) => {
  let data = await detectLocation.check_address({
    address: '200 Thích Quảng Đức',
    lat: 10.800757,
    lng: 106.681199,
    profile: 'osrm'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2003)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})