jest.setTimeout(30000)
var detectLocation = require('../index')

test('Võ Chí Công, Khu đô thị Ciputra, Tây Hồ',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Võ Chí Công, Khu đô thị Ciputra, Tây Hồ',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2005)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Đường 1A, Vĩnh Lộc B, Bình Chánh, Hồ Chí Minh',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Đường 1A, Vĩnh Lộc B, Bình Chánh, Hồ Chí Minh',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Đường Võ Chí Công, Tăng Nhơn Phú B, District 9, Ho Chi Minh City',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Đường Võ Chí Công, Tăng Nhơn Phú B, District 9, Ho Chi Minh City',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Ấp 1 Đường Kênh 7, Xã Tân Kiên, Huyện Bình Chánh',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Ấp 1 Đường Kênh 7, Xã Tân Kiên, Huyện Bình Chánh',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('ap 3 xa hung long',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'ap 3 xa hung long',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Phố Phú Minh, Phường Minh Khai, Quận Bắc Từ Liêm',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Phố Phú Minh, Phường Minh Khai, Quận Bắc Từ Liêm',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Tổ 15 động lãm hà đông , Phường Phú Lương, Quận Hà Đông, Hà Nội',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Tổ 15 động lãm hà đông , Phường Phú Lương, Quận Hà Đông, Hà Nội',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Khu Công Nghiệp An Hạ, Phạm Văn Hai, Bình Chánh',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Khu Công Nghiệp An Hạ, Phạm Văn Hai, Bình Chánh',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Khu Công Nghiệp Đồng An Tỉnh Lộ 743, Phường Bình Hòa, Thị Xã Thuận An',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Khu Công Nghiệp Đồng An Tỉnh Lộ 743, Phường Bình Hòa, Thị Xã Thuận An',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Khu Chế Xuất Tân Thuận, Tân Thuận, District 7, phường Tân Thuận Đông, Quận 7, Tân Thuận Đông Quận 7 Hồ Chí Minh, Việt Nam',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Khu Chế Xuất Tân Thuận, Tân Thuận, District 7, phường Tân Thuận Đông, Quận 7, Tân Thuận Đông Quận 7 Hồ Chí Minh, Việt Nam',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Khu Chế Xuất Linh Trung I, AH 1, Linh Trung, Thủ Đức',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Khu Chế Xuất Linh Trung I, AH 1, Linh Trung, Thủ Đức',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('KCN Lê Minh Xuân 3, Lê Minh Xuân, Bình Chánh, Hồ Chí Minh',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'KCN Lê Minh Xuân 3, Lê Minh Xuân, Bình Chánh, Hồ Chí Minh',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('KDC Nam Long, Tân Thuận Đông, Quận 7, Hồ Chí Minh',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'KDC Nam Long, Tân Thuận Đông, Quận 7, Hồ Chí Minh',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Khu Dân Cư Thới An Quận 12, Thới An, Quận 12',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Khu Dân Cư Thới An Quận 12, Thới An, Quận 12',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Khu Đô Thị Mizuki Park, Bình Hưng, Bình Chánh',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Khu Đô Thị Mizuki Park, Bình Hưng, Bình Chánh',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('KĐT Văn Phú',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'KĐT Văn Phú',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2006)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('Lô 3c Chung cư Phú Thọ, Nguyễn Thị Nhỏ, phường 15, Quận 11',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Lô 3c Chung cư Phú Thọ, Nguyễn Thị Nhỏ, phường 15, Quận 11',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2008)
  expect(data.wrong_details[0].confidence).toEqual(50)
  done()
})

test('Ô 2627, Lô C7 Khu đô thị Đại Kim, Phường Định Công, Quận Hoàng Mai, Hà Nội, Phường Định Công, Quận Hoàng Mai, Hà Nội',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Ô 2627, Lô C7 Khu đô thị Đại Kim, Phường Định Công, Quận Hoàng Mai, Hà Nội, Phường Định Công, Quận Hoàng Mai, Hà Nội',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2007)
  expect(data.wrong_details[0].confidence).toEqual(50)
  done()
})

test('Saroma Villa khu đô thị Sala, An Lợi Đông, Quận 2',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Saroma Villa khu đô thị Sala, An Lợi Đông, Quận 2',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2007)
  expect(data.wrong_details[0].confidence).toEqual(50)
  done()
})

test('621, 20 Ấp 3, Ấp 2, Vĩnh Lộc B, Bình Chánh, Hồ Chí Minh, Việt Nam',
async (done) => {
  let data = await detectLocation.check_address({
    address: '621, 20 Ấp 3, Ấp 2, Vĩnh Lộc B, Bình Chánh, Hồ Chí Minh, Việt Nam',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2007)
  expect(data.wrong_details[0].confidence).toEqual(50)
  done()
})

//2008
test('Scenic Valley Apartment, Phú Mỹ Hưng , P, Tân Phong, Quận 7, Hồ Chí Minh',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Scenic Valley Apartment, Phú Mỹ Hưng , P, Tân Phong, Quận 7, Hồ Chí Minh',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2008)
  expect(data.wrong_details[0].confidence).toEqual(50)
  done()
})

test('masteri an phú quận 2, Xa lộ Ha Noi, Thảo Điền, Quận 2, Hồ Chí Minh',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'masteri an phú quận 2, Xa lộ Ha Noi, Thảo Điền, Quận 2, Hồ Chí Minh',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2008)
  expect(data.wrong_details[0].confidence).toEqual(50)
  done()
})

test('Cty TNHH Giấy A.F.C, Vĩnh Lộc B, Bình Chánh, Ho Chi Minh City, Vietnam',
async (done) => {
  let data = await detectLocation.check_address({
    address: 'Cty TNHH Giấy A.F.C, Vĩnh Lộc B, Bình Chánh, Ho Chi Minh City, Vietnam',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2008)
  expect(data.wrong_details[0].confidence).toEqual(50)
  done()
})

test('61a Nguyễn Văn Huyên, Cầu Giấy, Hanoi',
async (done) => {
  let data = await detectLocation.check_address({
    address: '61a Nguyễn Văn Huyên, Cầu Giấy, Hanoi',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2009)
  expect(data.wrong_details[0].confidence).toEqual(50)
  done()
})

test('62c Trần Quốc Hoàn, Cầu Giấy, Hà Nội',
async (done) => {
  let data = await detectLocation.check_address({
    address: '62c Trần Quốc Hoàn, Cầu Giấy, Hà Nội',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2009)
  expect(data.wrong_details[0].confidence).toEqual(50)
  done()
})

//2010
test('1 Thái Hà, Láng Hạ, Đống Đa',
async (done) => {
  let data = await detectLocation.check_address({
    address: '1 Thái Hà, Láng Hạ, Đống Đa',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2010)
  expect(data.wrong_details[0].confidence).toEqual(50)
  done()
})

test('1 Đường số 8, Binh An, Quận 2, Hồ Chí Minh, Việt Nam',
async (done) => {
  let data = await detectLocation.check_address({
    address: '1 Đường số 8, Binh An, Quận 2, Hồ Chí Minh, Việt Nam',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(true)
  expect(data.wrong_details[0].is_wrong).toEqual(true)
  expect(data.wrong_details[0].code).toEqual(2010)
  expect(data.wrong_details[0].confidence).toEqual(50)
  done()
})


//OSRM
detectLocation.Init({
  osrm_url: 'https://route.ahamove.com/osrm'
})

test('48 Đường số 4,  An Phú',
async (done) => {
  let data = await detectLocation.check_address({
    address: '48 Đường số 4,  An Phú',
    osrm_address: 'Đường số 4',
    profile: 'osrm'
  })
  // console.log(data)
  expect(data.is_wrong).toEqual(false)
  expect(data.wrong_details[0].is_wrong).toEqual(false)
  expect(data.wrong_details[0].code).toEqual(1000)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('153/12 Nguyễn Văn Hưởng,  District 2,  Ho Chi Minh City',
async (done) => {
  let data = await detectLocation.check_address({
    address: '153/12 Nguyễn Văn Hưởng,  District 2,  Ho Chi Minh City',
    osrm_address: 'Nguyễn Văn Hưởng',
    profile: 'osrm'
  })
  expect(data.is_wrong).toEqual(false)
  expect(data.wrong_details[0].is_wrong).toEqual(false)
  expect(data.wrong_details[0].code).toEqual(1003)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('1041/62/139 Đường Trần Xuân Soạn, Phường Tân Hưng, Quận 7, Thành Phố Hồ Chí Minh',
async (done) => {
  let data = await detectLocation.check_address({
    address: '1041/62/139 Đường Trần Xuân Soạn, Phường Tân Hưng, Quận 7, Thành Phố Hồ Chí Minh',
    osrm_address: 'Hẻm 1041/62 Trần Xuân Soạn',
    profile: 'osrm'
  })
  expect(data.is_wrong).toEqual(false)
  expect(data.wrong_details[0].is_wrong).toEqual(false)
  expect(data.wrong_details[0].code).toEqual(1000)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('70 Lữ Gia, Phường 15, Quận 11, Hồ Chí Minh',
async (done) => {
  let data = await detectLocation.check_address({
    address: '70 Lữ Gia, Phường 15, Quận 11, Hồ Chí Minh',
    osrm_address: ' ',
    profile: 'osrm'
  })
  expect(data.is_wrong).toEqual(false)
  expect(data.wrong_details[0].is_wrong).toEqual(false)
  expect(data.wrong_details[0].code).toEqual(1001)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('692/63 Đoàn Văn Bơ,  District 4,  Ho Chi Minh City',
async (done) => {
  let data = await detectLocation.check_address({
    address: '692/63 Đoàn Văn Bơ,  District 4,  Ho Chi Minh City',
    osrm_address: ' ',
    profile: 'osrm'
  })
  expect(data.is_wrong).toEqual(false)
  expect(data.wrong_details[0].is_wrong).toEqual(false)
  expect(data.wrong_details[0].code).toEqual(1001)
  expect(data.wrong_details[0].confidence).toEqual(100)
  done()
})

test('827 Quang Trung, phường 12, Gò Vấp, Ho Chi Minh City',
async (done) => {
  let data = await detectLocation.check_address({
    address: '827 Quang Trung, phường 12, Gò Vấp, Ho Chi Minh City',
    profile: 'regex'
  })
  expect(data.is_wrong).toEqual(false)
  expect(data.wrong_details[0].is_wrong).toEqual(false)
  done()
})

